#include <dbupdate.h>
#include <pkutil.h>
#include <assassin.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>
#include <time.h>
#include <debug.h>


/**
 * @brief Check if the package database need to be updated or not. Here using time stamp to do this job.
 * @return 0 means no update needed, else is the package database need to be renew
 */ 
int db_update_check() {
	char file[MAX_PACKAGE_NAME_SIZE];
	char buf[MAX_PACKAGE_NAME_SIZE];
	struct stat s;
	int time_now,time_last;
	FILE *fp;

	snprintf(file, sizeof(file), "%s/%s", THEME_PATH, STAMPFILE);
	time_now = time(NULL);
	if (stat(file, &s) < 0) {
		debug("State file failed!!\n");
		fp = fopen(file, "w");
		if (!fp) {
			error("Open timestamp file %s failed!!\n",file);
			return 0;
		}
		snprintf(buf, sizeof(buf), "%d",time_now);
		fwrite(buf, sizeof(char),strlen(buf),fp);
		fclose(fp);
		return 0;
	}
	fp = fopen(file,"r");
	if (!fp) {
		error("Open timestamp file %s failed!!\n",file);
		return 0;
	}
	fread(buf,sizeof(char),sizeof(buf),fp);
	fclose(fp);
	time_last= atoi(buf);
	debug("The timestamp is %d\n",atoi(buf));
	if ((time_now - time_last) > TIMEOUT_S) {
		return 1;
	}
	return 0;
}

void put_time_stamp() {
	int time_now;
	FILE *fp;
	char buf[MAX_PACKAGE_NAME_SIZE];
	char file[MAX_PACKAGE_NAME_SIZE];
	time_now = time(NULL);
	snprintf(buf,sizeof(buf),"%d",time_now);
	snprintf(file, sizeof(file), "%s/%s", THEME_PATH, STAMPFILE);
	fp = fopen(file, "w");
	if (!fp) {
		error("Open timestamp file %s failed!!\n",file);
	}
	fwrite(buf, sizeof(char),strlen(buf),fp);
	fclose(fp);
}



int network_check() {
	// TODO: Current it's dummy here 
	// Wait for NM 0.7
	return 1;
}

static int __is_datebase_updating__ = 0;
void package_database_update() {
	Pk_Operation *pko;
	__is_datebase_updating__=1;
	pko = (Pk_Operation *) malloc (sizeof(Pk_Operation));
	pk_refresh_system(pko);	
}


void pk_refresh_finished_cb (void *data, DBusMessage *message) {
	pk_default_get_finished_cb (data,message);
	__is_datebase_updating__=0;
}

int package_database_updating() {
	return __is_datebase_updating__;
}
